AbstractProcessor (Java Platform SE 8 )
Keywords: javax.annotation.processing.AbstractProcessor class
Date: 2026-03-29

compact3
javax.annotation.processing

## Class AbstractProcessor

- java.lang.Object
- - javax.annotation.processing.AbstractProcessor

- All Implemented Interfaces:
    Processor

      public abstract class AbstractProcessor
      extends Object
      implements Processor

  An abstract annotation processor designed to be a convenient superclass for most concrete annotation processors. This class examines annotation values to compute the options, annotation types, and source version supported by its subtypes.

  The getter methods may issue warnings about noteworthy conditions using the facilities available after the processor has been initialized.

  Subclasses are free to override the implementation and specification of any of the methods in this class as long as the general `Processor` contract for that method is obeyed.

  Since:
    1.6

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected ProcessingEnvironment` | `processingEnv` Processing environment providing by the tool framework.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractProcessor()` Constructor for subclasses to call.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Iterable<? extends Completion>` | `getCompletions(Element element, AnnotationMirror annotation, ExecutableElement member, String userText)` Returns an empty iterable of completions.
    `Set<String>` | `getSupportedAnnotationTypes()` If the processor class is annotated with `SupportedAnnotationTypes`, return an unmodifiable set with the same set of strings as the annotation.
    `Set<String>` | `getSupportedOptions()` If the processor class is annotated with `SupportedOptions`, return an unmodifiable set with the same set of strings as the annotation.
    `SourceVersion` | `getSupportedSourceVersion()` If the processor class is annotated with `SupportedSourceVersion`, return the source version in the annotation.
    `void` | `init(ProcessingEnvironment processingEnv)` Initializes the processor with the processing environment by setting the `processingEnv` field to the value of the `processingEnv` argument.
    `protected boolean` | `isInitialized()` Returns `true` if this object has been initialized, `false` otherwise.
    `abstract boolean` | `process(Set<? extends TypeElement> annotations, RoundEnvironment roundEnv)` Processes a set of annotation types on type elements originating from the prior round and returns whether or not these annotation types are claimed by this processor.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### processingEnv

          protected ProcessingEnvironment processingEnv

      Processing environment providing by the tool framework.

  - ### Constructor Detail

    - #### AbstractProcessor

          protected AbstractProcessor()

      Constructor for subclasses to call.

  - ### Method Detail

    - #### getSupportedOptions

          public Set<String> getSupportedOptions()

      If the processor class is annotated with `SupportedOptions`, return an unmodifiable set with the same set of strings as the annotation. If the class is not so annotated, an empty set is returned.
      Specified by:
        `getSupportedOptions` in interface `Processor`
      Returns:
        the options recognized by this processor, or an empty set if none
      See Also:
        `SupportedOptions`

    - #### getSupportedAnnotationTypes

          public Set<String> getSupportedAnnotationTypes()

      If the processor class is annotated with `SupportedAnnotationTypes`, return an unmodifiable set with the same set of strings as the annotation. If the class is not so annotated, an empty set is returned.
      Specified by:
        `getSupportedAnnotationTypes` in interface `Processor`
      Returns:
        the names of the annotation types supported by this processor, or an empty set if none
      See Also:
        `SupportedAnnotationTypes`

    - #### getSupportedSourceVersion

          public SourceVersion getSupportedSourceVersion()

      If the processor class is annotated with `SupportedSourceVersion`, return the source version in the annotation. If the class is not so annotated, `SourceVersion.RELEASE_6` is returned.
      Specified by:
        `getSupportedSourceVersion` in interface `Processor`
      Returns:
        the latest source version supported by this processor
      See Also:
        `SupportedSourceVersion`, `ProcessingEnvironment.getSourceVersion()`

    - #### init

          public void init(ProcessingEnvironment processingEnv)

      Initializes the processor with the processing environment by setting the `processingEnv` field to the value of the `processingEnv` argument. An `IllegalStateException` will be thrown if this method is called more than once on the same object.
      Specified by:
        `init` in interface `Processor`
      Parameters:
        `processingEnv` - environment to access facilities the tool framework provides to the processor
      Throws:
        `IllegalStateException` - if this method is called more than once.

    - #### process

          public abstract boolean process(Set<? extends TypeElement> annotations,
                                          RoundEnvironment roundEnv)

      Processes a set of annotation types on type elements originating from the prior round and returns whether or not these annotation types are claimed by this processor. If `true` is returned, the annotation types are claimed and subsequent processors will not be asked to process them; if `false` is returned, the annotation types are unclaimed and subsequent processors may be asked to process them. A processor may always return the same boolean value or may vary the result based on chosen criteria.

      The input set will be empty if the processor supports `"*"` and the root elements have no annotations. A `Processor` must gracefully handle an empty set of annotations.

      Specified by:
        `process` in interface `Processor`
      Parameters:
        `annotations` - the annotation types requested to be processed
        `roundEnv` - environment for information about the current and prior round
      Returns:
        whether or not the set of annotation types are claimed by this processor

    - #### getCompletions

          public Iterable<? extends Completion> getCompletions(Element element,
                                                               AnnotationMirror annotation,
                                                               ExecutableElement member,
                                                               String userText)

      Returns an empty iterable of completions.
      Specified by:
        `getCompletions` in interface `Processor`
      Parameters:
        `element` - the element being annotated
        `annotation` - the (perhaps partial) annotation being applied to the element
        `member` - the annotation member to return possible completions for
        `userText` - source code text to be completed
      Returns:
        suggested completions to the annotation

    - #### isInitialized

          protected boolean isInitialized()

      Returns `true` if this object has been initialized, `false` otherwise.
      Returns:
        `true` if this object has been initialized, `false` otherwise.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.